#include <SDL.h>

SDL_Surface *new_set_gfx_mode() {
  UINT32 videoflags;
  SDL_Surface *s;
  videoflags = SDL_HWSURFACE | SDL_HWPALETTE;
  if ( (s=SDL_SetVideoMode(display_cfg.screen_x, display_cfg.screen_y,
			display_cfg.bpp, videoflags)) == NULL ) {
    fprintf(stderr,"could not setup %dx%d %d bpp\n",display_cfg.screen_x,display_cfg.screen_y,display_cfg.bp);
    exit(1);
  }
  return s;
}

void init_display() {
  SDL_Surface *s = new_set_gfx_mode();
  screen = surface_to_bmp(s);
}

void ScreenChange(void)
{
  //show_mouse(NULL);

  SDL_Surface *s;
   if((s=new_set_gfx_mode())==NULL){	// Didn't work:
      memcpy(&display_cfg, &prev_display_cfg, sizeof(DISPLAY_CFG));
      s = new_set_gfx_mode();	// Revert to old mode
   }
   else{
     ReClipScreen();
      if (prev_display_cfg.bpp != display_cfg.bpp) {
	if (current_colour_mapper){
	  set_colour_mapper(current_colour_mapper);
	  ResetPalette();
	}
      }
   }
   if (screen) free(screen);
   screen = surface_to_bmp(s);
   //show_mouse(screen);
}

void set_default_video_mode() {
  display_cfg.screen_x = 640;
  display_cfg.screen_y = 480;
  dispmay_cfg.bpp = 8;
}

